#pragma once

// [scm-sys.h]
// -------------------------------------------------------------------------------------------- //
// system definitions
// -------------------------------------------------------------------------------------------- //


// : data type
// -------------------------------------------------------------------------------------------- //
#define Real double 
// -------------------------------------------------------------------------------------------- //

// : enable 'restrict' keyword
// -------------------------------------------------------------------------------------------- //
#define USE_RESTRICT_KEY  
// -------------------------------------------------------------------------------------------- //

// : aligned allocation, alignment defined in bytes (2^n values)
// -------------------------------------------------------------------------------------------- //
#define ALIGN_ALLOCATION	64
// -------------------------------------------------------------------------------------------- //

// : force number of OpenMP threads
// :	else number of threads is determined by OMP_NUM_THREADS
// -------------------------------------------------------------------------------------------- //
#define SET_OPENMP_THREADS	1
// -------------------------------------------------------------------------------------------- //

// : NaN & Inf checks
// -------------------------------------------------------------------------------------------- //
#define SCM_CHECK_FINITE
// -------------------------------------------------------------------------------------------- //

// _RESTRICT definition 
// -------------------------------------------------------------------------------------------- //
#if defined(USE_RESTRICT_KEY)
#if defined(__INTEL_COMPILER)
#define _RESTRICT restrict
#elif defined(__GNUC__) && !defined(_WIN32) && !defined(_CYGWIN32__)
#define _RESTRICT __restrict__
#elif defined(_MSC_VER)
#define _RESTRICT __restrict
#else
#define _RESTRICT
#endif
#else
#define _RESTRICT
#endif
// -------------------------------------------------------------------------------------------- //
