#include <stdlib.h>
#include <stdio.h>
#include "../includeCXX/sfx_call_class_func.h"
#include "../includeCXX/sfx_esm.h"
#include "../includeCXX/sfx_sheba.h"
#include <vector>

// -------------------------------------------------------------------------- //
void surf_flux_esm_CXX (sfxDataVecTypeC* sfx,
                           meteoDataVecTypeC* meteo,
                           const sfx_esm_param* model_param, 
                           const sfx_surface_param* surface_param,
                           const sfx_esm_numericsTypeC* numerics,
                           const sfx_phys_constants* constants,
                           const int grid_size)
{
#ifdef INCLUDE_CUDA
    static FluxEsm<float, MemType::CPU, MemType::CPU, MemType::GPU> F(sfx, meteo, *model_param, *surface_param, *numerics, *constants, grid_size);
    F.compute_flux();
#else
    static FluxEsm<float, MemType::CPU, MemType::CPU, MemType::CPU> F(sfx, meteo, *model_param, *surface_param, *numerics, *constants, grid_size);
    F.compute_flux();
#endif
}

void surf_flux_sheba_CXX (sfxDataVecTypeC* sfx,
                           meteoDataVecTypeC* meteo,
                           const sfx_sheba_param* model_param, 
                           const sfx_surface_param* surface_param,
                           const sfx_sheba_numericsTypeC* numerics,
                           const sfx_phys_constants* constants,
                           const int grid_size)
{
// #ifdef INCLUDE_CUDA
//     static FluxSheba<float, MemType::CPU, MemType::CPU, MemType::GPU> F(sfx, meteo, *model_param, *surface_param, *numerics, *constants, grid_size);
//     F.compute_flux();
// #else
//     static FluxSheba<float, MemType::CPU, MemType::CPU, MemType::CPU> F(sfx, meteo, *model_param, *surface_param, *numerics, *constants, grid_size);
//     F.compute_flux();
// #endif
}