module C_FUNC

#if defined(INCLUDE_CXX)

    INTERFACE
        SUBROUTINE get_surface_fluxes_esm(sfx, meteo, model_param, surface_param, numerics, constants, grid_size) BIND(C)
            use sfx_data
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT, C_PTR
            IMPLICIT NONE
            INTEGER(C_INT) :: grid_size
            type(C_PTR), value :: sfx
            type(C_PTR), value :: meteo
            type(sfx_esm_param) :: model_param
            type(sfx_surface_param) :: surface_param
            type(sfx_esm_numericsTypeC) :: numerics
            type(sfx_phys_constants) :: constants
        END SUBROUTINE get_surface_fluxes_esm

        SUBROUTINE get_surface_fluxes_sheba(sfx, meteo, model_param, surface_param, numerics, constants, grid_size) BIND(C)
            use sfx_data
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT, C_PTR
            IMPLICIT NONE
            INTEGER(C_INT) :: grid_size
            type(C_PTR), value :: sfx
            type(C_PTR), value :: meteo
            type(sfx_sheba_param) :: model_param
            type(sfx_surface_param) :: surface_param
            type(sfx_sheba_numericsTypeC) :: numerics
            type(sfx_phys_constants) :: constants
        END SUBROUTINE get_surface_fluxes_sheba
    END INTERFACE

    contains

    subroutine set_c_struct_sfx_phys_constants_values(constants)
        use sfx_data
        use sfx_phys_const
        implicit none
        type (sfx_phys_constants), intent(inout) :: constants
        constants%Pr_m = Pr_m
        constants%g = g
        constants%nu_air = nu_air
    end subroutine set_c_struct_sfx_phys_constants_values
#endif
end module C_FUNC

